﻿using System;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.Web;
using System.Collections.Generic;
using DevExpress.ExpressApp.Xpo;

namespace NumeratorTestSolution.Web {
    // For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/DevExpressExpressAppWebWebApplicationMembersTopicAll.aspx
    public partial class NumeratorTestSolutionAspNetApplication : WebApplication {
        private DevExpress.ExpressApp.SystemModule.SystemModule module1;
        private DevExpress.ExpressApp.Web.SystemModule.SystemAspNetModule module2;
        private NumeratorTestSolution.Module.NumeratorTestSolutionModule module3;
        private DevExpress.ExpressApp.ConditionalAppearance.ConditionalAppearanceModule conditionalAppearanceModule1;
        private Xafari.XafariModule xafariModule1;
        private Xafari.Editors.XafariEditorsModule xafariEditorsModule1;
        private Xafari.DockPanels.XafariDockPanelsModule xafariDockPanelsModule1;
        private Xafari.BC.XafariBCModule xafariBCModule1;
        private Xafari.BC.Numerators.XafariBCNumeratorsModule xafariBCNumeratorsModule1;
        private Xafari.BC.Numerators.Xpo.XafariBCNumeratorsXpoModule xafariBCNumeratorsXpoModule1;
        private Xafari.Web.XafariWebModule xafariWebModule1;
        private NumeratorTestSolution.Module.Web.NumeratorTestSolutionAspNetModule module4;

        #region Default XAF configuration options (https://www.devexpress.com/kb=T501418)
        static NumeratorTestSolutionAspNetApplication() {
			EnableMultipleBrowserTabsSupport = true;
            DevExpress.ExpressApp.Web.Editors.ASPx.ASPxGridListEditor.AllowFilterControlHierarchy = true;
            DevExpress.ExpressApp.Web.Editors.ASPx.ASPxGridListEditor.MaxFilterControlHierarchyDepth = 3;
            DevExpress.ExpressApp.Web.Editors.ASPx.ASPxCriteriaPropertyEditor.AllowFilterControlHierarchyDefault = true;
            DevExpress.ExpressApp.Web.Editors.ASPx.ASPxCriteriaPropertyEditor.MaxHierarchyDepthDefault = 3;
            DevExpress.Persistent.Base.PasswordCryptographer.EnableRfc2898 = true;
            DevExpress.Persistent.Base.PasswordCryptographer.SupportLegacySha512 = false;
        }
        private void InitializeDefaults() {
            LinkNewObjectToParentImmediately = false;
            OptimizedControllersCreation = true;
        }
        #endregion
        public NumeratorTestSolutionAspNetApplication() {
            InitializeComponent();
			InitializeDefaults();
        }
        protected override void CreateDefaultObjectSpaceProvider(CreateCustomObjectSpaceProviderEventArgs args) {
            args.ObjectSpaceProvider = new XPObjectSpaceProvider(GetDataStoreProvider(args.ConnectionString, args.Connection), true);
            args.ObjectSpaceProviders.Add(new NonPersistentObjectSpaceProvider(TypesInfo, null));
        }
        private IXpoDataStoreProvider GetDataStoreProvider(string connectionString, System.Data.IDbConnection connection) {
            System.Web.HttpApplicationState application = (System.Web.HttpContext.Current != null) ? System.Web.HttpContext.Current.Application : null;
            IXpoDataStoreProvider dataStoreProvider = null;
            if(application != null && application["DataStoreProvider"] != null) {
                dataStoreProvider = application["DataStoreProvider"] as IXpoDataStoreProvider;
            }
            else {
                dataStoreProvider = XPObjectSpaceProvider.GetDataStoreProvider(connectionString, connection, true);
                if(application != null) {
                    application["DataStoreProvider"] = dataStoreProvider;
                }
            }
			return dataStoreProvider;
        }
        private void NumeratorTestSolutionAspNetApplication_DatabaseVersionMismatch(object sender, DevExpress.ExpressApp.DatabaseVersionMismatchEventArgs e) {
#if EASYTEST
            e.Updater.Update();
            e.Handled = true;
#else
            if(System.Diagnostics.Debugger.IsAttached) {
                e.Updater.Update();
                e.Handled = true;
            }
            else {
				string message = "The application cannot connect to the specified database, " +
					"because the database doesn't exist, its version is older " +
					"than that of the application or its schema does not match " +
					"the ORM data model structure. To avoid this error, use one " +
					"of the solutions from the https://www.devexpress.com/kb=T367835 KB Article.";

                if(e.CompatibilityError != null && e.CompatibilityError.Exception != null) {
                    message += "\r\n\r\nInner exception: " + e.CompatibilityError.Exception.Message;
                }
                throw new InvalidOperationException(message);
            }
#endif
        }
        private void InitializeComponent() {
            this.module1 = new DevExpress.ExpressApp.SystemModule.SystemModule();
            this.module2 = new DevExpress.ExpressApp.Web.SystemModule.SystemAspNetModule();
            this.module3 = new NumeratorTestSolution.Module.NumeratorTestSolutionModule();
            this.module4 = new NumeratorTestSolution.Module.Web.NumeratorTestSolutionAspNetModule();
            this.conditionalAppearanceModule1 = new DevExpress.ExpressApp.ConditionalAppearance.ConditionalAppearanceModule();
            this.xafariModule1 = new Xafari.XafariModule();
            this.xafariEditorsModule1 = new Xafari.Editors.XafariEditorsModule();
            this.xafariDockPanelsModule1 = new Xafari.DockPanels.XafariDockPanelsModule();
            this.xafariBCModule1 = new Xafari.BC.XafariBCModule();
            this.xafariBCNumeratorsModule1 = new Xafari.BC.Numerators.XafariBCNumeratorsModule();
            this.xafariBCNumeratorsXpoModule1 = new Xafari.BC.Numerators.Xpo.XafariBCNumeratorsXpoModule();
            this.xafariWebModule1 = new Xafari.Web.XafariWebModule();
            ((System.ComponentModel.ISupportInitialize)(this)).BeginInit();
            // 
            // xafariBCModule1
            // 
            this.xafariBCModule1.IsGenerateCustomMemberExts = false;
            // 
            // NumeratorTestSolutionAspNetApplication
            // 
            this.ApplicationName = "NumeratorTestSolution";
            this.CheckCompatibilityType = DevExpress.ExpressApp.CheckCompatibilityType.DatabaseSchema;
            this.Modules.Add(this.module1);
            this.Modules.Add(this.module2);
            this.Modules.Add(this.conditionalAppearanceModule1);
            this.Modules.Add(this.xafariModule1);
            this.Modules.Add(this.xafariEditorsModule1);
            this.Modules.Add(this.xafariDockPanelsModule1);
            this.Modules.Add(this.xafariBCModule1);
            this.Modules.Add(this.xafariBCNumeratorsModule1);
            this.Modules.Add(this.xafariBCNumeratorsXpoModule1);
            this.Modules.Add(this.module3);
            this.Modules.Add(this.xafariWebModule1);
            this.Modules.Add(this.module4);
            this.DatabaseVersionMismatch += new System.EventHandler<DevExpress.ExpressApp.DatabaseVersionMismatchEventArgs>(this.NumeratorTestSolutionAspNetApplication_DatabaseVersionMismatch);
            ((System.ComponentModel.ISupportInitialize)(this)).EndInit();

        }
    }
}
